function saveQueueForm(formObj)
{
	if(!validateName(formObj.name.value))
	{
		alert($i18n("fcm.sq.queue.js.saveQueueForm.alert0.txt"));
		formObj.name.select();
		formObj.name.focus();
		return false;
	}

	if(!validateDescription(formObj.description.value))
	{
		alert($i18n("fcm.sq.queue.js.saveQueueForm.alert1.txt"));
		formObj.description.select();
		formObj.description.focus();
		return false;
	}

	// Inactive/Closed status check
	if(formObj.status[1].checked || formObj.status[3].checked)
	{
		var statusValue = (formObj.status[1].checked) ? formObj.status[1].nextSibling.nodeValue : formObj.status[3].nextSibling.nodeValue
		statusValue = statusValue.replace(/\s+$/,"");// remove spaces from end of text node.
		if(!confirm($i18n("fcm.sq.queue.js.saveQueueForm.confirm0.0.fmt.txt",[statusValue])+"\n\n"+
			    $i18n("fcm.sq.queue.js.saveQueueForm.confirm0.1.txt")))
		return false;
	}

	if(parseInt(formObj.callLowerBound.value) > parseInt(formObj.callUpperBound.value))
	{
		alert($i18n("fcm.sq.queue.js.saveQueueForm.alert2.0.txt")+"\n"+
		      $i18n("fcm.sq.queue.js.saveQueueForm.alert2.1.fmt.txt",[formObj.callLowerBound.options[formObj.callLowerBound.selectedIndex].text,formObj.callUpperBound.options[formObj.callUpperBound.selectedIndex].text]));


		formObj.callLowerBound.focus();
		return false;
	}

	var atLeastOnePicked = $(":checkbox[name^='callResultId']").filter(":checked").length > 0 ;
	if(!atLeastOnePicked)
	{
		alert($i18n("fcm.sq.queue.js.saveQueueForm.alert3.txt"));
		return false;
	}

	if(!validateCallResultSettings(formObj))
		return false;


	if(isDefined(formObj.autoCloseNewAlert)){
		var days = parseInt(formObj.autoCloseNewAlert.value);
		if(isNaN(formObj.autoCloseNewAlert.value) || days != parseFloat(formObj.autoCloseNewAlert.value))
		{
			alert($i18n("fcm.sq.queue.js.saveQueueForm.alert4.txt"));
			formObj.autoCloseNewAlert.focus();
			formObj.autoCloseNewAlert.select();
			return false;
		}
		if(days < 0 || days > 360)
		{
			alert($i18n("fcm.sq.queue.js.saveQueueForm.alert5.txt"));
			formObj.autoCloseNewAlert.focus();
			formObj.autoCloseNewAlert.select();
			return false;
		}
	}
	if(isDefined(formObj.systemBlockDays)){
		var days = parseInt(formObj.systemBlockDays.value);
		if(isNaN(formObj.systemBlockDays.value) || days != parseFloat(formObj.systemBlockDays.value))
		{
			alert($i18n("fcm.sq.queue.js.saveQueueForm.alert6.txt"));
			formObj.systemBlockDays.focus();
			formObj.systemBlockDays.select();
			return false;
		}
		if(days < 0 || days > 360)
		{
			alert($i18n("fcm.sq.queue.js.saveQueueForm.alert7.txt"));
			formObj.systemBlockDays.focus();
			formObj.systemBlockDays.select();
			return false;
		}
	}
	if(isDefined(formObj.transactionBlockDays)){
		var days = parseInt(formObj.transactionBlockDays.value);
		if(isNaN(formObj.transactionBlockDays.value) || days != parseFloat(formObj.transactionBlockDays.value))
		{
			alert($i18n("fcm.sq.queue.js.saveQueueForm.alert8.txt"));
			formObj.transactionBlockDays.focus();
			formObj.transactionBlockDays.select();
			return false;
		}
		if(days < 0 || days > 360)
		{
			alert($i18n("fcm.sq.queue.js.saveQueueForm.alert9.txt"));
			formObj.transactionBlockDays.focus();
			formObj.transactionBlockDays.select();
			return false;
		}
	}
	//High Risk Combo
	if(isDefined(document.getElementById("comboListbox"))){
		if(document.getElementById("comboListbox").options.length>0){
			if(isDefined(formObj.warningMsg)){
				if(formObj.warningMsg.value==""){
					alert($i18n("fcm.sq.queue.js.saveQueueForm.alert10.txt"));
					formObj.warningMsg.focus();
					formObj.warningMsg.select();
					return false;
				}
			}
		}
	}

	//getElement("saveButton").disabled = true;

	for (var i = 0; i < _itemPriorityList.length; i++)
	{
		obj = _itemPriorityList[i];
		// don't pass loaded queue in
		if(obj.priority != obj.newPriority)
		{
			// Queue New Priority
			ele = document.createElement("input");
			ele.type = "hidden";
			ele.name = "newQueuePriority("+obj.id+")";
			ele.value = ""+obj.newPriority+":"+obj.version;
			formObj.appendChild(ele);
		}
	}

	comboListAssignment();
	postAssignment(emailList,'emailsStr');
	postAssignment(letterList,'lettersStr');
	postAssignment(smsList,'smssStr');

	formObj.callSuperseded.value = (formObj.callSupersededCheckbox.checked?"0":"1");
	formObj.stickyQueue.value = (formObj.stickyQueueCheckbox.checked?"1":"0");
	formObj.method.value="save";

	postPosCodes(formObj);
	postFraudTypes(formObj);
	postAllowRerouteTo(formObj);
	postSystemBlocks(formObj);
	postTransactionBlocks(formObj);

	$(":checkbox[name^='suppressAutoFulfill']").prop("disabled", false);
//	alert ("submitting...");

	setBusy();
}


function postAssignment(arrayList,eleName)
{
	var assignedElement = document.createElement("input");
	assignedElement.type = "hidden";
	assignedElement.name = eleName;
	assignedElement.value = "";

	for (var i = 0, len = arrayList.length; i < len; i++)
	{
		var item = arrayList[i];
		if(item.isAssigned)
		{
			assignedElement.value += item.id+":";
		}

	}

	if(assignedElement.value.length > 0)
		document.queueForm.appendChild(assignedElement);

}


function postPosCodes(formObj)
{
	for (var j=0; j< crs.length; j++)
	{
		var cr = crs[j];
		if (cr.isAssigned && (cr.typeUnknown || cr.typePositive))
		{
			var crChk = formObj.elements["callResultId("+cr.id+")"];
			if(isDefined(crChk) && crChk.checked)
			{
				var posChk = formObj.elements["pos("+cr.id+")"];
				var elem = formObj.elements["posCodes("+cr.id+")"];
				var posCodes = "";

				if(posChk.checked)
				{
					for (var i =0; i < posCodesByCallResult[""+cr.id].length; i++)
					{
						if(posCodesByCallResult[""+cr.id][i].isAssigned)
						{
							posCodes += posCodesByCallResult[""+cr.id][i].id + ",";
						}
					}
					elem.value = posCodes;
					if(elem.value.length > 0) elem.disabled = false;
			    }
			}
		}
	}
}

function postAllowRerouteTo(formObj)
{
	for (var j=0; j< crs.length; j++)
	{
		var cr = crs[j];
		if (cr.isAssigned && cr.typeUnknown )
		{
			var crChk = formObj.elements["callResultId("+cr.id+")"];
			if(isDefined(crChk) && crChk.checked)
			{
				var rerouteChk=formObj.elements["applyAllowRerouteTo("+cr.id+")"];
				var elem = formObj.elements["allowRerouteTo("+cr.id+")"];
				var allowRerouteToStr = "";

				if(rerouteChk.checked)
				{
					for (var i =0; i < allowRerouteTo[""+cr.id].length; i++)
					{
						if(allowRerouteTo[""+cr.id][i].isAssigned)
						{
							allowRerouteToStr += allowRerouteTo[""+cr.id][i].id + ",";
						}
					}
					elem.value = allowRerouteToStr;
					if(elem.value.length > 0) elem.disabled = false;
			    }
			}
		}
	}
}

function postFraudTypes(formObj)
{
	for (var j=0; j< crs.length; j++)
	{
		var cr = crs[j];
		if (cr.isAssigned && cr.typeNegative)
		{
			var crChk = formObj.elements["callResultId("+cr.id+")"];
			if(isDefined(crChk) && crChk.checked)
			{
				var elem = formObj.elements["fraudTypes("+cr.id+")"];
				var fraudTypesStr = "";

				for (var i =0; i < fraudTypes[""+cr.id].length; i++)
				{
					if(fraudTypes[""+cr.id][i].isAssigned)
					{
						fraudTypesStr += fraudTypes[""+cr.id][i].id + ",";
					}
				}
				elem.value = fraudTypesStr;
				if(elem.value.length > 0) elem.disabled = false;
			}
		}
	}
}

function postSystemBlocks(formObj)
{
	for (var j=0; j< crs.length; j++)
	{
		var cr = crs[j];
		if (cr.isAssigned)
		{
			var crChk = formObj.elements["callResultId("+cr.id+")"];
			if(isDefined(crChk) && crChk.checked)
			{
				var sysBlockChk=formObj.elements["applySystemBlock("+cr.id+")"];
				var elem = formObj.elements["systemBlocks("+cr.id+")"];
				var systemBlocksStr = "";

				if(sysBlockChk.checked)
				{
					for (var i =0; i < sysBlocksByCallResult[""+cr.id].length; i++)
					{
						if(sysBlocksByCallResult[""+cr.id][i].isAssigned)
						{
							systemBlocksStr += sysBlocksByCallResult[""+cr.id][i].id + ",";
						}
					}
					elem.value = systemBlocksStr;
					if(elem.value.length > 0) elem.disabled = false;
			    }
			}
		}
	}
}


function postTransactionBlocks(formObj)
{
	for (var j=0; j< crs.length; j++)
	{
		var cr = crs[j];
		if (cr.isAssigned)
		{
			var crChk = formObj.elements["callResultId("+cr.id+")"];
			if(isDefined(crChk) && crChk.checked)
			{
				var transBlockChk=formObj.elements["applyTransactionBlock("+cr.id+")"];
				var elem = formObj.elements["transactionBlocks("+cr.id+")"];
				var transactionBlocksStr = "";

				if(transBlockChk.checked )
				{
					for (var i =0; i < txnBlocksByCallResult[""+cr.id].length; i++)
					{
						if(txnBlocksByCallResult[""+cr.id][i].isAssigned)
						{
							transactionBlocksStr += txnBlocksByCallResult[""+cr.id][i].id + ",";
						}
					}
					elem.value = transactionBlocksStr;
					if(elem.value.length > 0) elem.disabled = false;
				}
			}
		}
	}
}

function isInteger(chk,ipt)
{

	if(isDefined(chk) && chk.checked)
	{
		return isIntegerValue(ipt.value);
	}
	return true;
}

function isIntegerValue(valueStr)
{
	if(valueStr.length > 0 && valueStr.indexOf('.') < 0 && !isNaN(valueStr))
		return !isNaN(parseInt(valueStr));
	return false;
}

function isFloat(chk,ipt)
{
	if(isDefined(chk) && chk.checked)
	{
		var valueStr = ipt.value;
		if(valueStr.length > 0 && !isNaN(valueStr))
			return !isNaN(parseFloat(valueStr));
		return false;
	}
	return true;
}

function isEmpty(ipt)
{
	if(isDefined(ipt))
	{
		var valueStr = ipt.value.replace(/\s/g, "");
		return (valueStr.length == 0);
	}
	return true;
}

function validateCallResultSettings(formObj)
{

	if(!isDefined(formObj))
	{
		alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert0.txt"));
		return false;
	}

	var ipt, chk;

	for (var i = 0; i < crs.length; i++)
	{
		if (!crs[i].isAssigned) continue;

		var cr = crs[i];
		var callResult = ""+cr.id;
		var label = cr.name;

		var crChk =formObj.elements["callResultId("+callResult+")"];

		if(!crChk.checked) continue;

		// validate auto close days
		ipt = formObj.elements["autoClose("+callResult+")"];
		if(!isInteger(crChk,ipt))
		{
			alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert4.txt"));
			ipt.focus();
			ipt.select();
			return false;
		}

		// only allow values between 0 and 360
		var days = parseInt(ipt.value);
		if(days < 0 || days > 360)
		{
			alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert5.txt"));
			ipt.focus();
			ipt.select();
			return false;
		}

		var rerouteChecked = false;
		var timeOptionSelected = false;
		var transOptionSelected = false;

		// validate reroute and time based resurface selection
		if (cr.typeUnknown) {

			//validate reroute selection
			chk = formObj.elements["applyAllowRerouteTo("+callResult+")"];
			rerouteChecked = chk.checked;
			if (rerouteChecked){
				ipt=formObj.elements["selectedAllowRerouteTo("+callResult+")"];
				if(!ipt.options.length>0) {
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert22.fmt.txt",[label]));
					ipt.focus();
					return false;
				}
			}

			//validate time selection
			var timeChk = formObj.elements["resurfaceAtTime("+callResult+")"];
			if (timeChk.checked)
			{
				var timeOption;
				if (rerouteChecked){
					timeOption = $(":radio[name='time("+callResult+")']").filter(":checked");
				}
				else {
					timeOption = $(":radio[name='time("+callResult+")'][value!='0']").filter(":checked");
				}

				if (timeOption.length > 0)
				{
					timeOptionSelected = true;

					// same day option selected, validate the minutes
					if (timeOption[0].value == "1") {
						chk = timeOption[0];
						ipt = formObj.elements["minutesValue("+callResult+")"];
						if(!isInteger(chk,ipt))
						{
							alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert1.txt"));
							ipt.focus();
							ipt.select();
							return false;
						}

						// values between 1 minute and 10 hours
						var unitValue = formObj.elements["minutesUnit("+callResult+")"].value;
						var timeValue = parseInt(ipt.value);

						if(unitValue == 'min' && timeValue < 1) // data entry limited to two digits
						{
							alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert2.txt"));
							ipt.focus();
							ipt.select();
							return false;
						}
						else if(unitValue == 'hr' && (timeValue < 1 || timeValue > 10))
						{
							alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert3.txt"));
							ipt.focus();
							ipt.select();
							return false;
						}
					}
				}

				//checked but no time option selected
				if (!timeOptionSelected) {
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert17.fmt.txt",[label]));
					timeChk.focus();
					return false;
				}

			} // end time validation

			// reroute must company with a time based resurface condition
			if (rerouteChecked && !timeOptionSelected)
			{
				alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert24.fmt.txt",[label]));
				timeChk.focus();
				return false;
			}

		} // end type = UNKNOWN

		// validate transaction based resurface selection
		if (cr.typeUnknown || cr.typePositive) {
			var transChk = formObj.elements["resurfaceWhenTrans("+callResult+")"];
			if (transChk.checked) {

				chk = formObj.elements["scoreIncrease("+callResult+")"];
				var ipt1 = formObj.elements["score1IncreaseValue("+callResult+")"];
				var ipt2 = formObj.elements["score2IncreaseValue("+callResult+")"];
				var ipt3 = formObj.elements["score3IncreaseValue("+callResult+")"];
				var ipt4 = formObj.elements["score4IncreaseValue("+callResult+")"];
				if(chk && chk.checked) transOptionSelected = true;
				if (!isEmpty(ipt1) && !isInteger(chk,ipt1))
				{
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert6.txt"));
					ipt1.focus();
					ipt1.select();
					return false;
				}

				if (!isEmpty(ipt2) && !isInteger(chk,ipt2))
				{
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert6.txt"));
					ipt2.focus();
					ipt2.select();
					return false;
				}

				if (!isEmpty(ipt3) && !isInteger(chk,ipt3))
				{
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert6.txt"));
					ipt3.focus();
					ipt3.select();
					return false;
				}

				if (!isEmpty(ipt4) && !isInteger(chk,ipt4))
				{
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert6.txt"));
					ipt4.focus();
					ipt4.select();
					return false;
				}

				chk = formObj.elements["score("+callResult+")"];
				ipt1 = formObj.elements["score1Value("+callResult+")"];
				ipt2 = formObj.elements["score2Value("+callResult+")"];
				ipt3 = formObj.elements["score3Value("+callResult+")"];
				ipt4 = formObj.elements["score4Value("+callResult+")"];
				if(chk && chk.checked)	transOptionSelected = true;
				if ( !isEmpty(ipt1) && !isInteger(chk,ipt1) )
				{
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert7.txt"));
					ipt1.focus();
					ipt1.select();
					return false;
				}
				if ( !isEmpty(ipt2) && !isInteger(chk,ipt2) )
				{
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert7.txt"));
					ipt2.focus();
					ipt2.select();
					return false;
				}
				if ( !isEmpty(ipt3) && !isInteger(chk,ipt3) )
				{
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert7.txt"));
					ipt3.focus();
					ipt3.select();
					return false;
				}

				if ( !isEmpty(ipt4) && !isInteger(chk,ipt4) )
				{
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert7.txt"));
					ipt4.focus();
					ipt4.select();
					return false;
				}

				chk = formObj.elements["amount("+callResult+")"];
				ipt = formObj.elements["amountValue("+callResult+")"];
				if(chk && chk.checked) transOptionSelected = true;
				if(!isFloat(chk,ipt))
				{
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert8.txt"));
					ipt.focus();
					ipt.select();
					return false;
				}

				chk = formObj.elements["merchantCountry("+callResult+")"];
				if(chk && chk.checked) {
					transOptionSelected = true;
					ipt=formObj.elements["merchantCountryCodesValue("+callResult+")"];
					if(ipt.value==''){
						alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert9.fmt.txt",[label]));
						ipt.focus();
						ipt.select();
						return false;
					}
					var notChk=formObj.elements["merchantCountryNot("+callResult+")"];
					if(notChk && notChk.checked){
						var notIn=formObj.elements["notMerchantCountryCodesValue("+callResult+")"].value.split(";");
						var both="";
						for (var z=0;z<notIn.length;z++){
							if(notIn!=''){
								if(ipt.value.indexOf(notIn[z])>-1){
									both+=notIn[z] + "\n\t ";
								}
							}
						}
						if(both!=""){
							alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert10.0.txt")+"\r\t"+
							      $i18n("fcm.sq.queue.js.validateCallResultSettings.alert10.1.fmt.txt",[both])+"\r"+
							      $i18n("fcm.sq.queue.js.validateCallResultSettings.alert10.2.txt"));
							ipt.focus();
							ipt.select();
							return false;
						}
					}
				}

				chk = formObj.elements["merchantCountryNot("+callResult+")"];
				if(chk && chk.checked) {
					transOptionSelected = true;
					ipt=formObj.elements["notMerchantCountryCodesValue("+callResult+")"];
					if(ipt.value==''){
						alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert11.fmt.txt",[label]));
						ipt.focus();
						ipt.select();
						return false;
					}
				}

				chk = formObj.elements["sic("+callResult+")"];
				if(chk && chk.checked) {
					transOptionSelected= true;
					ipt=formObj.elements["sicCodesValue("+callResult+")"];
					if(ipt.value==''){
						alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert12.fmt.txt",[label]));
						ipt.focus();
						ipt.select();
						return false;
					}
					var notChk=formObj.elements["notSic("+callResult+")"];
					if(notChk && notChk.checked){
						var notIn=formObj.elements["notSicCodesValue("+callResult+")"].value.split(";");
						var both="";
						for (var z=0;z<notIn.length;z++){
							if(notIn!=''){
								if(ipt.value.indexOf(notIn[z])>-1){
									both+=notIn[z] + "\n\t ";
								}
							}
						}
						if(both!=""){
							alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert13.0.txt")+"\r\t"+
							$i18n("fcm.sq.queue.js.validateCallResultSettings.alert13.1.fmt.txt",[both])+"\r"+
							$i18n("fcm.sq.queue.js.validateCallResultSettings.alert13.2.txt"));
							ipt.focus();
							ipt.select();
							return false;
						}
					}
				}

				chk = formObj.elements["notSic("+callResult+")"];
				if(chk && chk.checked) {
					transOptionSelected = true;
					ipt=formObj.elements["notSicCodesValue("+callResult+")"];
					if(ipt.value==''){
						alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert14.fmt.txt",[label]));
						ipt.focus();
						ipt.select();
						return false;
					}
				}

				chk = formObj.elements["ard("+callResult+")"];
				if(chk && chk.checked) {
					transOptionSelected = true;
					var ardSelected=false;
					var obj=formObj.elements["ardCodesValue("+callResult+")"];
					for (var j=0; j<obj.length; j++){
						if (obj[j].checked)
							ardSelected=true;
					}
					if(!ardSelected){
						alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert15.fmt.txt",[label]));
						return false;
					}
				}
				if(chk && !chk.checked){
					var obj=formObj.elements["ardCodesValue("+callResult+")"];
					for (var j=0; j<obj.length; j++){
						obj[j].checked=false;
					}
				}

				chk = formObj.elements["pos("+callResult+")"];
				if(chk && chk.checked) {
					transOptionSelected = true;
					var obj=formObj.elements["selectedPosCodes("+callResult+")"].options;
					ipt=formObj.elements["selectedPosCodes("+callResult+")"];
					if(!obj.length>0) {
						alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert16.fmt.txt",[label]));
						ipt.focus();
						return false;
					}
				}

				if (!transOptionSelected) {
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert18.fmt.txt",[label]));
					transChk.focus();
					return false;
				}

			} // end of transaction validation
		} // end type = UNKNOWN | POSITIVE

//		if (cr.typeUnknown) {
//			if(!timeOptionSelected && !transOptionSelected)
//			{
//				alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert19.fmt.txt",[label]));
//				crChk.focus();
//				return false;
//			}
//		}

		// validate block code selections
		chk = formObj.elements["applyTransactionBlock("+callResult+")"];
		if(chk && chk.checked) {
			var applyTransactionBlockSelected=false;
			var obj=formObj.elements["selectedTransactionBlocks("+callResult+")"].options;
			ipt=formObj.elements["selectedTransactionBlocks("+callResult+")"];
			if(obj.length>0) {
				applyTransactionBlockSelected=true;
			}
			if(!applyTransactionBlockSelected){
				alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert20.fmt.txt",[label]));
				ipt.focus();
				return false;
			}

		}
		chk = formObj.elements["applySystemBlock("+callResult+")"];
		if(chk && chk.checked) {
			var applySystemBlockSelected=false;
			var obj=formObj.elements["selectedSystemBlocks("+callResult+")"].options;
			ipt=formObj.elements["selectedSystemBlocks("+callResult+")"];
			if(obj.length>0) {
				applySystemBlockSelected=true;
			}
			if(!applySystemBlockSelected){
				alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert21.fmt.txt",[label]));
				ipt.focus();
				return false;
			}
		}

		if(cr.typeNegative){
			ipt=formObj.elements["selectedFraudTypes("+callResult+")"];
			if(!ipt.options.length>0) {
				alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert23.fmt.txt",[label]));
				ipt.focus();
				return false;
			}
		}

	}//end forloop

	return true;
}


function toggleConfiguration(chkbx,linkName, divName)
{
	if(chkbx.checked)
	{
		hideDiv(linkName);
		showDiv(divName);
	}
	else
	{
		showDiv(linkName);
		hideDiv(divName);
	}
}

function disableCallResultOptions(prefix,isDisabled)
{
	elms = document.queueForm.elements;

	for (var i = 0; i < elms.length; i++)
	{
		if(isDefined(elms[i].id) && elms[i].id.indexOf(prefix) == 0)
		{
			elms[i].disabled = isDisabled;
		}

	}

}

function enableElements(resultName,elemNameList,isDisabled)
{
	for (var i = 0; i < elemNameList.length; i++)
	{
		var elem = document.queueForm.elements[elemNameList[i]+"("+resultName+")"];

		if(isDefined(elem))
		{
			// array elements, but not a "select"
			if (elem.length && !isDefined(elem.type))
			{
				for (var j = 0; j < elem.length; j++)
					enableElement(elem[j], isDisabled);
			}
			else
			{
				enableElement(elem, isDisabled)
			}
		}
	}
}

function enableElement(elem, isDisabled)
{
	if(elem.checked) elem.click();
	if(isDefined(isDisabled)){
		elem.disabled = isDisabled;
	}
}

function setStickySetting(chkbx,stickyChkbx)
{
	if(chkbx.checked)
	{
		stickyChkbx.checked = true;
		stickyChkbx.disabled = true;
	}
	else
	{
		stickyChkbx.disabled = false;
	}
}

function activate(chkbox,txtFldName)
{
	txtFld = document.queueForm[txtFldName];

	txtFld.disabled = !chkbox.checked;
	txtFld.disabled == true ? txtFld.blur() : txtFld.focus();

}
function showQueuePriorityList()
{
	doHide(document.queueForm.callLowerBound)
	doHide(document.queueForm.callUpperBound);
	doHide(document.queueForm.sortField);
	doHide(document.queueForm.sortOrder);
//	doHide(document.queueForm.queueTypeCode);

	var aTag = getElement('queueRelativePriority')
	var srcRowIndex = parseInt(aTag.innerHTML);
	var tableRef = getElement('queuePriorityTable');
	var qpList = getElement('queuePriorityList');
	qpList.style.top = getTopPosition(aTag);
	qpList.style.left = getLeftPosition(aTag);

	showDiv('','queuePriorityList');

	for (var i = 0,scrollTop = 0; i < srcRowIndex-2; i++)
	{
		scrollTop += tableRef.rows[i].offsetHeight;
	}
	qpList.scrollTop = scrollTop;
}

function setQueuePriority(rowRef)
{

	srcRowIndex = parseInt(getElement('queueRelativePriority').innerHTML) - 1;
	tgtRowIndex = rowRef.rowIndex - 1;

	tableRef = getElement('queuePriorityTableBody');
	if(srcRowIndex != tgtRowIndex)
	{
		newRow = moveRow(tableRef,srcRowIndex,tgtRowIndex);
		swapItemPriority(srcRowIndex,tgtRowIndex);
		swapItemLocation(srcRowIndex, tgtRowIndex);
		highlightRow(newRow,'rowSelected');

		// reset relative priorities value for all rows
		numRows = tableRef.getElementsByTagName("TR").length;
		for (var i = 0; i < numRows; i++)
		{
			tableRef.rows[i].cells[0].innerHTML = (i+1);
		}
	}

	getElement('queueRelativePriority').innerHTML=(tgtRowIndex+1)+" ";
	hideQueuePriorityList();
}

function hideQueuePriorityList()
{
	doShow(document.queueForm.callLowerBound)
	doShow(document.queueForm.callUpperBound);
	doShow(document.queueForm.sortField);
	doShow(document.queueForm.sortOrder);
	hideDiv('queuePriorityList');
}



function enableDivElements(resultName,elemNameList, on)
{

	toggleDiv(resultName+'WhenOptionsDiv',on);

	enableElements(resultName,elemNameList,on);

}
var _emailType = 0;
var _letterType = 1;
var _smsType = 2;
var _defaultTemplateIds = ["-101","-101","-101"];

function populateDefaultFields(templateType, defaultItem){


	//CHANGE THE COLOR OF THE OPTION TO INDICATE IT IS DEFAULT
	defaultItem.className = "defaultTemplateItem";

	if(templateType==0){
		var arrayList = emailList;
		var item = arrayList[defaultItem.value];
		if(item.isAssigned)
		document.queueForm.defaultEmail.value=item.id;
		$('#defaultEmailDisplay').text(defaultItem.text);

	}
	else if(templateType==1){
		var arrayList = letterList;
		var item = arrayList[defaultItem.value];
		document.queueForm.defaultLetter.value=item.id;
		$('#defaultLetterDisplay').text(defaultItem.text);

	}
	else if(templateType==2){
		var arrayList = smsList;
		var item = arrayList[defaultItem.value];
		document.queueForm.defaultSms.value=item.id;
		$('#defaultSmsDisplay').text(defaultItem.text);
	}
}

function setAsDefaultItem(evt, listBoxName)
{
	//DETERMINE THE TEMPLATE TYPE
	if (listBoxName.indexOf("Emails")>0) var templateType=_emailType;
	else if (listBoxName.indexOf("Letters")>0) var templateType=_letterType;
	else var templateType=_smsType;

	//DETERMINE WHICH LISTBOX IS MAKING THE CALL
	var caller = document.getElementsByName(listBoxName)[0];
	//IF NO SELECTIONS ARE MADE RETURN
	if(caller.selectedIndex == -1) return;

	for (var i = 0; i < caller.options.length; i++)
	{
		//DETERMINE THE POSITION OF THE OPTION
		var defaultItem = caller.options[i];
		//IF OPTION IS THE SELECTED OPTION
		if(i == caller.selectedIndex)
		{
			//POPULATE _defaultTemplateIds[templateType] WITH THE POSITION OF THE SELECTED OPTION
			_defaultTemplateIds[templateType] = defaultItem.value;

			//POPULATE THE HIDDEN FIELD defaultEmail with the templateId-THIS WILL BE SAVED IN THE queueForm
			//DISPLAY THE DEFAULT TEMPLATE WITH THE TEMPLATE NAME
			populateDefaultFields(templateType, defaultItem);

		}
		//TURN THE PREVIOUS DEFAULT TO REGULAR COLOR
		else if(defaultItem.className == "defaultTemplateItem")
		{
			defaultItem.className = "";

		}
	}
	//DESELECT ALL OPTIONS
	caller.selectedIndex = -1;
}

//CALLED WHEN A USER ASSIGNS NEW TEMPLATES OR REMOVES TEMPLATES
function selectDefaultItem(evt,listBoxName)
{

	//DETERMINE THE TEMPLATE TYPE
	if (listBoxName.indexOf("Emails")>0) var templateType=_emailType;
	else if (listBoxName.indexOf("Letters")>0) var templateType=_letterType;
	else var templateType=_smsType;

	//DETERMINE WHICH LISTBOX IS MAKING THE CALL
	var caller = document.getElementsByName(listBoxName)[0];
	//INITIALIZE EXISTS FLAG TO FALSE
	var exists = false;

	//LOOP THROUGH ALL THE LISTBOX OPTIONS
	for (var i = 0; i < caller.options.length; i++)
	{
		var defaultItem = caller.options[i];
		var len=caller.options.length;
		defaultItem.className=="";

		//IF WE HAD ALREADY SAVED A DEFAULT
		//OR
		//IF THE POSITION OF THE CURRENT OPTION IS THE SAME AS THE PREVIOUS DEFAULT TEMPLATE
		if(defaultItem.value == _defaultTemplateIds[templateType] ){

			//alert("THE PREVIOUS DEFAULT TEMPLATE STILL EXISTS: " + defaultItem.value);

			//CHANGE THE THE DEFAULT FIELDS
			populateDefaultFields(templateType, defaultItem);

			//SET THE EXIST VALUE TO TRUE
			exists = true;
		}
		if(!exists && _defaultTemplateIds[templateType]>=0){//THE PREVIOUS DEFAULT TEMPLATE HAS BEEN REMOVED
			if(_defaultTemplateIds[templateType]<defaultItem.value || i==len-1){
				//alert("THE DEFAULT DOES NOT EXIST ANYMORE.  TAKE THE OPTION THAT WAS IN THE PREVIOUS DEFAULTS POSITION OR IF IT DOESN'T EXIST TAKE THE LAST ONE: " + defaultItem.value);

				_defaultTemplateIds[templateType]=defaultItem.value;

				//SET NEW DEFAULT VALUES
				populateDefaultFields(templateType, defaultItem);

				//STOP LOOPING
				break;
			}
		}
	}
	if(!exists){//NO PREVIOUS DEFAULT OR NO OPTIONS IN LISTBOX

		if (len>0){//THERE ARE OPTIONS IN THE LISTBOX
			//NO PREVIOUS DEFAULT TEMPLATE, SO WE SET DEFAULT TO THE FIRST OPTION ON THE LIST
			if(_defaultTemplateIds[templateType]<0){
				//alert("THERE WAS NO PREVIOUS DEFAULT TEMPLATE SO WE SET IT TO THE FIRST ONE ON THE LIST");
				var defaultItem=caller.options[0];
				_defaultTemplateIds[templateType] = defaultItem.value;
				populateDefaultFields(templateType,defaultItem);
			}


		}
		else{//THERE ARE NO OPTIONS IN THE LISTBOX
			//alert("THERE ARE NO OPTIONS IN THE LISTBOX");
			_defaultTemplateIds[templateType]="-101";
			if(templateType==0){
				document.queueForm.defaultEmail.value="";
				document.getElementById('defaultEmailDisplay').innerHTML ="";
			}
			if(templateType==1){
				document.queueForm.defaultLetter.value="";
				document.getElementById('defaultLetterDisplay').innerHTML ="";
			}
			if(templateType==2){
				document.queueForm.defaultSms.value="";
				document.getElementById('defaultSmsDisplay').innerHTML ="";
			}

		}
	}
}



/****NEW BBW***/

//maximum number of allowed checked boxes
var maxChecks=4;

function limitSelections(obj){

	var checkCount= $(":checkbox[name='" + obj.name + "']").filter(":checked").length;

	//if they checked a 5th box, uncheck the box, then decrement checkcount and pop alert
	if (checkCount>maxChecks){
		alert($i18n("fcm.sq.queue.js.limitSelections.alert0.fmt.txt",[maxChecks]));
		obj.checked=false;
	}
}


function populateText(){

	var selValues='';
	var cntr=0;
	var existingValues=document.getElementById(_name).value;
	var existingValuesArray = existingValues.split(" ; ");
	if(existingValues!='') cntr=existingValuesArray.length;


	var obj=document.getElementById("selMerchantCountry");

	for (var i=0;i<obj.options.length;i++){
			if(obj.options[i].selected==true){
				cntr++;
				if(cntr<11){
					if(selValues!='') selValues=selValues+" ; "+obj.options[i].value;
					else {
						if(existingValues!='') existingValues=existingValues+" ; ";
						selValues=obj.options[i].value;
					}
				}
				else{
					alert($i18n("fcm.sq.queue.js.populateText.alert0.txt"));
					return false;
				}
				obj.options[i].selected=false;
			}
	}

	document.getElementById(_name).value=existingValues+selValues;
	document.getElementById(_name).focus();
}

var _name="";

function maxSel(form, max){
	var ctr = 0;
	for (var i=0; i<form.options.length; i++)
	{
		if (form.options[i].selected==true)
			ctr++;
			if(ctr>max){
				form.options[i].selected=false;
			}
	}

	if (ctr>max)
	{
		alert($i18n("fcm.sq.queue.js.maxSel.alert0.fmt.txt",[max]));
		return false;
	}

	return true;
}

function showHideBlock(divName,callResult){
	if(document.getElementById(divName+callResult).style.display=='none') {
		document.getElementById(divName+callResult).style.display='inline';
	}
	else {
		document.getElementById(divName+callResult).style.display='none';
	}
}


/***********************************************
* Drop Down/ Overlapping Content-  Dynamic Drive (www.dynamicdrive.com)
* This notice must stay intact for legal use.
* Visit http://www.dynamicdrive.com/ for full source code
***********************************************/

function getposOffset(overlay, offsettype){
	var totaloffset=(offsettype=="left")? overlay.offsetLeft : overlay.offsetTop;
	var parentEl=overlay.offsetParent;
	while (parentEl!=null){
		totaloffset=(offsettype=="left")? totaloffset+parentEl.offsetLeft : totaloffset+parentEl.offsetTop;
		parentEl=parentEl.offsetParent;
	}
	return totaloffset;
}

function overlay(curobj, subobjstr, opt_position){


	if(curobj.disabled)return false;

	highlightSelections();

	if (document.getElementById){
		var subobj=document.getElementById(subobjstr)
		subobj.style.display=(subobj.style.display!="block")? "block" : "none"
		var xpos=getposOffset(curobj, "left")+((typeof opt_position!="undefined" && opt_position.indexOf("right")!=-1)? -(subobj.offsetWidth-curobj.offsetWidth) : 0)
		var ypos=getposOffset(curobj, "top")+((typeof opt_position!="undefined" && opt_position.indexOf("bottom")!=-1)? curobj.offsetHeight : 0)
		subobj.style.left=xpos+"px"
		subobj.style.top=ypos+"px"
		return false
	}
	else
		return true
}



function overlayclose(subobj){

	for (var i=0;i<document.queueForm.selMerchantCountry.options.length;i++){
		document.queueForm.selMerchantCountry.options[i].style.color="black";
		document.queueForm.selMerchantCountry.options[i].selected=false;
	}
	document.getElementById(subobj).style.display="none";
}

function processCodeDescription(valid, invalid, obj,notInBothChk) {

	if(!invalid==''){
		alert($i18n("fcm.sq.queue.js.processCodeDescription.alert0.fmt.txt", [invalid]));
		return;
	}

	//country and sic codes cannot exist in both in and not in conditions
	if(notInBothChk){
		notInBoth(obj,valid);
 	}

	var validArr=valid.split(";");
	if (validArr.length>10){
		valid='';
		for (var i=0;i<10;i++){
			if(valid=='')valid+=validArr[i];
			else valid+=" ; "+validArr[i];
		}
		alert($i18n("fcm.sq.queue.js.processCodeDescription.alert1.txt"));
	}
	document.queueForm.elements[obj].value=valid;
	document.queueForm.elements[obj].style.color="green";

	window.status = '';

}

function getCodeDescription(obj,type,code,notInBoth) {

	code=RegExp.escape(code);
 	code = code.replace(/['"]/g,"");
	code = code.replace(/[ ,]/g , ";");
	window.status = 'Loading data...';

	try {
		var url = "a_codeDesc.sj?method=getDescription&callingPage=queuePage&type=" + type + "&code=" + code+"&obj="+obj+"&notInBoth="+notInBoth;
		var hiddenIFrame = window.frames['codeLookupFrame'];
		hiddenIFrame.document.location.replace(url);
	}
	catch(e) {
		window.status = 'Error loading data.';
	}
}

function enableLookup(elemName){

	elem=document.getElementById(elemName);
	var isDisabled=!elem.disabled;
	if(isDefined(elem)){
		if(isDefined(isDisabled)){
			elem.disabled=isDisabled;
		}
	}

}

function extractCallResult(obj){

	if(!obj)obj=_name;
	var start=obj.indexOf('(');
	var callResult=obj.substring(start+1);
	var end=callResult.indexOf(')');

	return callResult.substring(0,end);
}
function highlightSelections(){

	var callResult=extractCallResult();

	var selections=document.getElementById('merchantCountryCodesValue('+callResult+')').value;
	var notSelections=document.getElementById('notMerchantCountryCodesValue('+callResult+')').value;
	var sels=selections.split(" ; ");
	for (var i=0;i<document.queueForm.selMerchantCountry.options.length;i++){
		for (var j=0;j<sels.length;j++){
			if(document.queueForm.selMerchantCountry.options[i].value==sels[j]){
				document.queueForm.selMerchantCountry.options[i].style.color="green";
			}
		}
	}
	sels=notSelections.split(" ; ");
	for (var i=0;i<document.queueForm.selMerchantCountry.options.length;i++){
		for (var j=0;j<sels.length;j++){
			if(document.queueForm.selMerchantCountry.options[i].value==sels[j]){
				document.queueForm.selMerchantCountry.options[i].style.color="red";
			}
		}
	}
}


function notInBoth(obj, valid){

	var callResult=extractCallResult(obj);
	var n=obj.replace('('+callResult+')','');
	var allowableLength=3;
	var m;
	if(obj.indexOf('Country')>-1){
		m= (n!='merchantCountryCodesValue') ? "merchantCountryCodesValue" : "notMerchantCountryCodesValue";
	}
	else {
		m= (n!='sicCodesValue') ? "sicCodesValue" : "notSicCodesValue";
		allowableLength=4;
	}
	var mLabel =(m.indexOf('not')>-1) ? "NOT IN" : "IN";
	var rmv = document.getElementById(m+'('+callResult+')').value.toString();
	var rmvArr=valid.split(";");
	var codesInBoth='';

	for (var z=0;z<rmvArr.length;z++){
		if(rmv!='' && trim(rmvArr[z]).length==allowableLength && rmv.indexOf(trim(rmvArr[z].toString()))>-1){
			rmv=rmv.replace(trim(rmvArr[z].toString()),' ');
			if(codesInBoth=='') codesInBoth=trim(rmvArr[z]);
			else codesInBoth+=" ; " + trim(rmvArr[z]) ;
		}
	}

	if(codesInBoth!=''  && document.getElementById(m+'('+callResult+')').disabled==false)
		alert($i18n("fcm.sq.queue.js.notInBoth.alert0.0.txt")+"\n"+
		$i18n("fcm.sq.queue.js.notInBoth.alert0.1.fmt.txt",[mLabel])+"\n\n"+
		$i18n("fcm.sq.queue.js.notInBoth.alert0.2.fmt.txt",[codesInBoth]));


	rmv=rmv.replace(/[ ;,]/g,'');

	var newRmv='';
	if(rmv.length>=allowableLength){
		var z=0;
		for (var i=allowableLength;i<=rmv.length;i=i+allowableLength){
			if(newRmv=='')newRmv=rmv.substring(z,i);
			else newRmv+=" ; "+rmv.substring(z,i);
			z=z+allowableLength;
		}
	}

	processCodeDescription(newRmv, '', m+'('+callResult+')',false);
	window.status='';

}
function validateCountryCodes(obj,code, notInBothChk){

 	code=RegExp.escape(code);

 	code = code.replace(/['"]/g,"");
	code = code.replace(/[ ,]/g , ";");
	var manyCodes=code.split(";");
	var valid="";
	var invalid="";
	var flag=false;
	var max=manyCodes.length;

	for (var i=0; i<max;i++){
		for (var j=0;j<_countryCodes.length;j++){
			if(trim(manyCodes[i])==_countryCodes[j]){
				flag=true;
				break;
			}
		}
		var re= RegExp(trim(manyCodes[i]));
		if(flag){
			if(!valid.match(re)){
				if(valid=="")valid=trim(manyCodes[i]);
				else valid+=" ; " + trim(manyCodes[i]);
			}
		}
		else{
			if(!invalid.match(re)){
				if(invalid=="")invalid=trim(manyCodes[i]);
				else invalid+= " ; " + trim(manyCodes[i]);
			}
		}
		flag=false;
	}
	processCodeDescription(valid, invalid, obj,notInBothChk);


}
function trim(txt)
{
	if (txt)
		return txt.replace(/^\s+/g, '').replace(/\s+$/g, '');
	else
		return "";
}

RegExp.escape = (function() {
	var specials = ['^','!','@','#','%','&','-','_','=',':','>','<','`','~','$','/', '.', '*', '+', '?', '|','(', ')', '[', ']', '{', '}', '\\' ];

	sRE = new RegExp('(\\' + specials.join('|\\') + ')', 'g');

	return function(text) {
		return text.replace(sRE, '');
	}
})();

function comboListAssignment(){

	var $arrayList=$('#comboListbox option');
	var assignedElement = document.createElement("input");

	assignedElement.type = "hidden";
	assignedElement.name = "warningComboStr";
	assignedElement.id = "warningComboStr";
	assignedElement.value = "";

	$arrayList.each(function(i){
		assignedElement.value += $(this).val()+":";
	});

	if(assignedElement.value.length>0){
		document.queueForm.appendChild(assignedElement);
	}


}
function addComboToListbox(blockCodeSelector,groupCodeSelector,comboListbox){

	var blockCodeValue=$('#blockCodeSelector option:selected').val();
	var groupCodeValue=$('#groupCodeSelector option:selected').val();

	var blockCodeText=$('#blockCodeSelector option:selected').html();
	var groupCodeText=$('#groupCodeSelector option:selected').html();

	if(blockCodeValue=='all' || groupCodeValue =='all'){
			if(blockCodeValue =='all' && groupCodeValue !='all'){

				$('#blockCodeSelector option').each(function(i){
					if(i!=0){
						var comboValue=$(this).val() + "~" +groupCodeValue;
						var comboText=$(this).html() + " & " +groupCodeText;
						addIfDoesntExist(comboListbox,comboValue,comboText);
					}
				});
			}
			else if(blockCodeValue !='all' && groupCodeValue =='all'){
				$('#groupCodeSelector option').each(function(i){
					if(i!=0){
						var comboValue=blockCodeValue + "~" +$(this).val();
						var comboText=blockCodeText + " & " +$(this).html();
						addIfDoesntExist(comboListbox,comboValue,comboText);
					}
				});
			}
			else{
				var $comboListbox = $('#'+comboListbox);
				$comboListbox.find('option').remove();
				var options = [];
				var $blockOptions = $('#blockCodeSelector option:gt(0)');
				var $groupOptions = $('#groupCodeSelector option:gt(0)');
				$blockOptions.each(function(i,blockOption){
					$groupOptions.each(function(j,groupOption){
							var comboValue=$(blockOption).val() + "~" +$(groupOption).val() ;
							var comboText=$(blockOption).html() + " & " +$(groupOption).html();
							options.push('<option value="'+comboValue+'">'+comboText+'</option>');
					});
				});
				$comboListbox.append(options.join(''));
			}
	}
	else{
		var comboValue=blockCodeValue+ "~" +groupCodeValue;
		var comboText=blockCodeText+" & " +groupCodeText;
		addIfDoesntExist(comboListbox,comboValue,comboText);
	}

	if($('#comboListbox option').size()>0)
		document.getElementById("removeCombosAnchor").disabled=false;
}
function addIfDoesntExist(comboListbox,comboValue,comboText){
	var $comboListbox  = $('#'+comboListbox);
	var $option = $comboListbox.find('option[value="'+comboValue+'"]');
	if($option.size() == 0){
		$comboListbox.append('<option value="'+comboValue+'">'+comboText+'</option>');
    }
}


function removeOptions(selectbox)
{
	var $selectbox=$('#'+selectbox);
	$($selectbox).find('option:selected').remove();
	if($selectbox.find('option').size()==0)
		$('#removeCombosAnchor').prop("disabled",true);
}


function populateCallResultsSelection()
{
	var ctrl = $("#availableCallResults")[0];
	for (var i = 0; i < crs.length; i++)
		if (!crs[i].isAssigned)
			ctrl.options.add( new Option(crs[i].name, i) );

	if (ctrl.options.length > 1)
		$("#addCallResultSection").css("display", "");

}

function populateSelectedCallResults()
{
	for (var i=0; i<crs.length; i++)
	{
		var cr = crs[i];
		if (cr.isAssigned == true)
		{
			$("#addCallResultSection").before($("#qcrTemplate" + cr.type).html().replace(/_CRID_/g, cr.id));
			$(":checkbox[name='callResultId("+cr.id+")']")[0].click();
	//		initializeQCRSection(cr, crSettings[i]);
		}
	}
}

function createQCRSection()
{
	var ctrl = $("#availableCallResults")[0];
	if ( ctrl.selectedIndex > 0 )
	{
		var cr = crs[ctrl.value];
		var setting = crSettings[ctrl.value];

		$("#addCallResultSection").before($("#qcrTemplate" + cr.type).html().replace(/_CRID_/g, cr.id));
		$(":checkbox[name='callResultId("+cr.id+")']")[0].click();
//		initializeQCRSection(cr, setting);
		cr.isAssigned = true;
		ctrl.remove(ctrl.selectedIndex);
	}
	if (ctrl.options.length <= 1)
		$("#addCallResultSection").css("display", "none");

}

function initializeQCRSection(cr, setting)
{
	var ids = "" + cr.id;
	var idp = "("+cr.id+")";

	var common = $("#callResult" + cr.id);
	var ext = $("#callResult" + cr.id + "Ext");

	// common
	$(common).find("#callResultName" + cr.id).text(cr.name);
	if (setting.status == 'INACTIVE')
		$(common).find("#callResultName" + cr.id).css("color", "orange").attr("title", setting.status);

	$(common).find("input[name='callResultName" + idp + "']")[0].value = cr.name;

	if (setting.autoClose != null)
		$(common).find("input[name='autoClose" + idp + "']")[0].value = setting.autoClose;

	if (cr.typeUnknown)
		$(common).find(":checkbox[name='suppressAutoFulfill" + idp + "']")[0].checked = setting.suppressAutoFulfill;
	else
		$(common).find(":checkbox[name='suppressAutoFulfill" + idp + "']")[0].checked = true;

	var sortOrder = $("#callResultBlock > td > table").length / 2 - 1;
	$(common).find("input[name='callResultSortOrder" + idp + "']").val(sortOrder).change(function () {
		crRow = $("#callResult" + ids);
		nextPos = $(this).val();
		if (!isIntegerValue(nextPos)) {
			$(this).val(($(crRow).index() + 1) / 2);
			return;
		}
		nextPos = nextPos * 2;
		moveCallResultRow(nextPos, crRow);
	});

	// block codes
	loadListboxByAssignment(txnBlocksByCallResult[ids], "availableTransactionBlocksContainer" + cr.id, false);
	loadListboxByAssignment(txnBlocksByCallResult[ids], "selectedTransactionBlocksContainer" + cr.id, true);

	loadListboxByAssignment(sysBlocksByCallResult[ids], "availableSystemBlocksContainer" + cr.id, false);
	loadListboxByAssignment(sysBlocksByCallResult[ids], "selectedSystemBlocksContainer" + cr.id, true);

	if (setting.applyTransactionBlock)
		$(ext).find(":checkbox[name='applyTransactionBlock" + idp + "']")[0].click();
	if (setting.applySystemBlock)
		$(ext).find(":checkbox[name='applySystemBlock" + idp + "']")[0].click();
	$(ext).find(":checkbox[name='removeTransactionBlock" + idp + "']")[0].checked = setting.removeTransactionBlock;
	$(ext).find(":checkbox[name='removeSystemBlock" + idp + "']")[0].checked = setting.removeSystemBlock;

	if (cr.typeUnknown)
	{
		// reroute
		loadListboxByAssignment(allowRerouteTo[ids], "availableAllowRerouteToContainer" + cr.id, false);
		loadListboxByAssignment(allowRerouteTo[ids], "selectedAllowRerouteToContainer" + cr.id, true);

		if (setting.allowRerouteToEnabled)
			$(ext).find(":checkbox[name='applyAllowRerouteTo" + idp + "']")[0].click();

		$(ext).find(":checkbox[name='applyAllowRerouteTo" + idp + "']").click(function() {
			if ( $(this).attr("checked") )
			{
				var chkAtTime = $(":checkbox[name='resurfaceAtTime" + idp + "']")[0];
				if (!chkAtTime.checked)
				{
					chkAtTime.click();
					$(":radio[name='time" + idp + "'][value='0']")[0].click();
				}
			}
		});

		// time based criteria

		if (setting.immediatelyEnabled || setting.minutesEnabled || setting.nextDayEnabled || setting.timestampEnabled )
			$(ext).find(":checkbox[name='resurfaceAtTime" + idp + "']")[0].click();

		if (setting.immediatelyEnabled )
			$(ext).find(":radio[name='time" + idp + "'][value='0']")[0].click();

		if (setting.minutesEnabled )
		{
			$(ext).find(":radio[name='time" + idp + "'][value='1']")[0].click();
			if(setting.minutes > 59){
				$(ext).find("input[name='minutesValue" + idp + "']")[0].value = setting.minutes/60;
				$(ext).find("select[name='minutesUnit" + idp + "']")[0].selectedIndex = 1; // hours
			}
			else{
				$(ext).find("input[name='minutesValue" + idp + "']")[0].value = setting.minutes;
				$(ext).find("select[name='minutesUnit" + idp + "']")[0].selectedIndex = 0; // hours
			}
		}
		if (setting.nextDayEnabled )
			$(ext).find(":radio[name='time" + idp + "'][value='2']")[0].click();
		if (setting.timestampEnabled )
			$(ext).find(":radio[name='time" + idp + "'][value='3']")[0].click();
	}

	if (cr.typeUnknown || cr.typePositive )
	{
		// transaction based criteria

		loadListboxByAssignment(posCodesByCallResult[ids], "availablePosCodesContainer" + cr.id, false);
		loadListboxByAssignment(posCodesByCallResult[ids], "selectedPosCodesContainer" + cr.id, true);

		if (setting.anyScoreIncreaseEnabled || setting.anyScoreEnabled || setting.amountEnabled || setting.ardEnabled ||
				setting.merchantCountryEnabled || setting.notMerchantCountryEnabled || setting.sicEnabled || setting.notSicEnabled || setting.posEnabled )
			$(ext).find(":checkbox[name='resurfaceWhenTrans" + idp + "']")[0].click();

		if (setting.merchantCountryEnabled || setting.notMerchantCountryEnabled || setting.sicEnabled || setting.notSicEnabled || setting.posEnabled )
		{
			if ($(ext).find("#ccBBWSection" + ids).css("display") == "none")
				$(ext).find("#ccBBWBar" + ids)[0].click();
		}
		else {
			if ($(ext).find("#ccBBWSection" + ids).css("display") != "none")
				$(ext).find("#ccBBWBar" + ids)[0].click();
		}

		if (setting.anyScoreIncreaseEnabled)
		{
			$(ext).find(":checkbox[name='scoreIncrease" + idp + "']")[0].click();
			if (setting.score1Increase != null)
				$(ext).find(":text[name='score1IncreaseValue" + idp + "']")[0].value = setting.score1Increase;
			if (setting.score2Increase != null)
				$(ext).find(":text[name='score2IncreaseValue" + idp + "']")[0].value = setting.score2Increase;
			if (setting.score3Increase != null)
				$(ext).find(":text[name='score3IncreaseValue" + idp + "']")[0].value = setting.score3Increase;
			if (setting.score4Increase != null)
				$(ext).find(":text[name='score4IncreaseValue" + idp + "']")[0].value = setting.score4Increase;
		}
		if (setting.anyScoreEnabled)
		{
			$(ext).find(":checkbox[name='score" + idp + "']")[0].click();
			if (setting.score1 != null)
				$(ext).find(":text[name='score1Value" + idp + "']")[0].value = setting.score1;
			if (setting.score2 != null)
				$(ext).find(":text[name='score2Value" + idp + "']")[0].value = setting.score2;
			if (setting.score3 != null)
				$(ext).find(":text[name='score3Value" + idp + "']")[0].value = setting.score3;
			if (setting.score4 != null)
				$(ext).find(":text[name='score4Value" + idp + "']")[0].value = setting.score4;
		}

		if (setting.amountEnabled)
		{
			$(ext).find(":checkbox[name='amount" + idp + "']")[0].click();
			if (setting.amount != null)
				$(ext).find(":text[name='amountValue" + idp + "']")[0].value = setting.amount;
		}

		if (setting.ardEnabled)
		{
			$(ext).find(":checkbox[name='ard" + idp + "']")[0].click();
			for (var i=0; i < setting.ardCodes.length; i++)
			{
				$(ext).find(":checkbox[name='ardCodesValue" + idp + "'][value='" + setting.ardCodes[i]+ "']").click();
			}
		}

		if (setting.merchantCountryEnabled)
		{
			$(ext).find(":checkbox[name='merchantCountry" + idp + "']")[0].click();
			$(ext).find(":text[name='merchantCountryCodesValue" + idp + "']")[0].value = setting.merchantCountryCodes.join(" ; ");
		}
		if (setting.notMerchantCountryEnabled)
		{
			$(ext).find(":checkbox[name='merchantCountryNot" + idp + "']")[0].click();
			$(ext).find(":text[name='notMerchantCountryCodesValue" + idp + "']")[0].value = setting.notMerchantCountryCodes.join(" ; ");
		}
		if (setting.sicEnabled)
		{
			$(ext).find(":checkbox[name='sic" + idp + "']")[0].click();
			$(ext).find(":text[name='sicCodesValue" + idp + "']")[0].value = setting.sicCodes.join(" ; ");
		}
		if (setting.notSicEnabled)
		{
			$(ext).find(":checkbox[name='notSic" + idp + "']")[0].click();
			$(ext).find(":text[name='notSicCodesValue" + idp + "']")[0].value = setting.notSicCodes.join(" ; ");
		}
		if (setting.posEnabled)
		{
			$(ext).find(":checkbox[name='pos" + idp + "']")[0].click();
		}
	}

	if (cr.typeNegative)
	{
		// fraud type
		loadListboxByAssignment(fraudTypes[ids], "availableFraudTypesContainer" + cr.id, false);
		loadListboxByAssignment(fraudTypes[ids], "selectedFraudTypesContainer" + cr.id, true);
	}
}


function resetQCRSection(cr)
{
	var ids = "" + cr.id;
	var idp = "("+cr.id+")";

	var ext = $("#callResult" + cr.id + "Ext");

	for (var i = 0; i < txnBlocksByCallResult[ids].length; i++ ){
		txnBlocksByCallResult[ids][i].isAssigned = txnBlocksByCallResult[ids][i].isInitAssigned;
	}
	for (var i = 0; i < sysBlocksByCallResult[ids].length; i++ ){
		sysBlocksByCallResult[ids][i].isAssigned = sysBlocksByCallResult[ids][i].isInitAssigned;
	}

	if (cr.typeUnknown)
	{
		$(ext).find(":checkbox[name='applyAllowRerouteTo" + idp + "']").unbind();
		for (var i = 0; i < allowRerouteTo[ids].length; i++ ){
			allowRerouteTo[ids][i].isAssigned = allowRerouteTo[ids][i].isInitAssigned;
		}

		$(ext).find(":text[name='minutesValue" + idp + "']").prop("disabled", true);
		$(ext).find("select[name='minutesUnit" + idp + "']").prop("disabled", true);
		$(ext).find(":radio[name='time" + idp + "']").prop("checked", false);
	}

	if (cr.typeUnknown || cr.typePositive)
	{
		for (var i = 0; i < posCodesByCallResult[ids].length; i++ ){
			posCodesByCallResult[ids][i].isAssigned = posCodesByCallResult[ids][i].isInitAssigned;
		}

		if ($(ext).find("#ccBBWSection" + ids).css("display") != "none")
			$(ext).find("#ccBBWBar" + ids)[0].click();

	}

	if (cr.typeNegative)
	{
		for (var i = 0; i < fraudTypes[ids].length; i++ ){
			fraudTypes[ids][i].isAssigned = fraudTypes[ids][i].isInitAssigned;
		}
	}

	$(":checkbox[name$='" + idp + "']").prop("checked", false);
	$(":text[name$='" + idp + "'][name").prop("value", "");
}

function reinitQCRSection(qcrCtrl)
{
	for (var i=0; i<crs.length; i++)
	{
		if (crs[i].id == qcrCtrl.value)
		{
			if (qcrCtrl.checked)
				initializeQCRSection(crs[i], crSettings[i]);
			else
				resetQCRSection(crs[i]);
			return;
		}
	}
}

function moveCallResultRow(nextPos, crRow)
{
	crExtRow = $(crRow).next();
	children = $(crRow).parent().children();

	currPos = $(crRow).index();
	total = $(children).length;
	if (nextPos <= 0) nextPos = 2;
	else if (nextPos >= total-1) nextPos = total - 2;
	delta = nextPos - currPos;

	if (delta == 0 ) return;

	if (delta > 0) {
		$(children).filter(":eq(" + nextPos +")").after($(crRow));
	}else{
		$(children).filter(":eq(" + (nextPos - 1) +")").before($(crRow));
	}
	$(crRow).after($(crExtRow));
	updateSortOrders();
}

function updateSortOrders()
{
	$("#callResultBlock :text[name^='callResultSortOrder']").each(function (index) {$(this).val(index+1)});
}
