


call sysproc.set_routine_opts('ISOLATION UR') @
CREATE OR REPLACE  PROCEDURE UPD_XACT_FRAUD_FLAG (
    IN I_TABNAME	CHARACTER(50),
    IN I_ALERT_ID	BIGINT,
    IN I_ALERT_VERSION_NBR INTEGER,    
    IN I_ALERT_TYPE CHARACTER(1),
    IN I_RESULT_ID	INTEGER,    
    IN I_USER_NAME	CHARACTER(60),
    IN I_FRAUD_IND	CHARACTER(1),
    IN I_ELEMENT_COUNT	SMALLINT,
    IN I_TRANSACTION_ID_1	BIGINT,
    IN I_TRANSACTION_ID_2	BIGINT,
    IN I_TRANSACTION_ID_3	BIGINT,
    IN I_TRANSACTION_ID_4	BIGINT,
    IN I_TRANSACTION_ID_5	BIGINT,
    IN I_TRANSACTION_ID_6	BIGINT,
    IN I_TRANSACTION_ID_7	BIGINT,
    IN I_TRANSACTION_ID_8	BIGINT,
    IN I_TRANSACTION_ID_9	BIGINT,
    IN I_TRANSACTION_ID_10	BIGINT,
    IN I_TRANSACTION_ID_11	BIGINT,
    IN I_TRANSACTION_ID_12	BIGINT,
    IN I_TRANSACTION_ID_13	BIGINT,
    IN I_TRANSACTION_ID_14	BIGINT,
    IN I_TRANSACTION_ID_15	BIGINT,
    IN I_TRANSACTION_ID_16	BIGINT,
    IN I_TRANSACTION_ID_17	BIGINT,
    IN I_TRANSACTION_ID_18	BIGINT,
    IN I_TRANSACTION_ID_19	BIGINT,
    IN I_TRANSACTION_ID_20	BIGINT,
    IN I_TRANSACTION_ID_21	BIGINT,
    IN I_TRANSACTION_ID_22	BIGINT,
    IN I_TRANSACTION_ID_23	BIGINT,
    IN I_TRANSACTION_ID_24	BIGINT,
    IN I_TRANSACTION_ID_25	BIGINT,
    IN I_TRANSACTION_ID_26	BIGINT,
    IN I_TRANSACTION_ID_27	BIGINT,
    IN I_TRANSACTION_ID_28	BIGINT,
    IN I_TRANSACTION_ID_29	BIGINT,
    IN I_TRANSACTION_ID_30	BIGINT,
    IN I_TRANSACTION_ID_31	BIGINT,
    IN I_TRANSACTION_ID_32	BIGINT,
    IN I_TRANSACTION_ID_33	BIGINT,
    IN I_TRANSACTION_ID_34	BIGINT,
    IN I_TRANSACTION_ID_35	BIGINT,
    IN I_TRANSACTION_ID_36	BIGINT,
    IN I_TRANSACTION_ID_37	BIGINT,
    IN I_TRANSACTION_ID_38	BIGINT,
    IN I_TRANSACTION_ID_39	BIGINT,
    IN I_TRANSACTION_ID_40	BIGINT,
    IN I_TRANSACTION_ID_41	BIGINT,
    IN I_TRANSACTION_ID_42	BIGINT,
    IN I_TRANSACTION_ID_43	BIGINT,
    IN I_TRANSACTION_ID_44	BIGINT,
    IN I_TRANSACTION_ID_45	BIGINT,
    IN I_TRANSACTION_ID_46	BIGINT,
    IN I_TRANSACTION_ID_47	BIGINT,
    IN I_TRANSACTION_ID_48	BIGINT,
    IN I_TRANSACTION_ID_49	BIGINT,
    IN I_TRANSACTION_ID_50	BIGINT,
    IN I_NEED_TO_COMMIT	CHARACTER(1) )
  SPECIFIC UPD_XACT_FRAUD_FL2
  LANGUAGE SQL
  NOT DETERMINISTIC
  EXTERNAL ACTION
  MODIFIES SQL DATA
  CALLED ON NULL INPUT
  INHERIT SPECIAL REGISTERS
-----------------------------------------------------------------------------
-- File:  UPD_XACT_FRAUD_FLAG.SQL
--
--
-- Description:
--     Sets or unsets the cmx_user_fraud_ind column for a given account,
--     transaction_type, and array of transactions.
--
-- Called By:
--     SAVE_ALERT_AND_TRAN_IDS
--         SET_XACT_FRAUD_FLAG
--
-- Calls:
--     N/A
--
-- Notes:
--     Originally stolen from specific procedure UPD_XACT_FRAUD_FLA.
--
-- Usage:
--
--
-- History:
--     Date          User                Notes
--     2008/03/07    leushe				 Added new parameter I_FRAUD_IND
--     						             created (stolen) from specific procedure UPD_XACT_FRAUD_FLA
--     2009/06/23    leushe				 Added new parameter I_ALERT_TYPE and upgraded the proc for V3 compatibility
--     2010/09/28    leushe              Added support for T,W,H alert types and msg api fields
--     2012/05/05    leushe              changed the proc to persist new columns to the FMX_FAUD_UPDT and change the process flow
--                                       no longer mutually exclusive markings, save CF alert info.
--     2013/06/21    leushe              Prevent a marking from being overwritten, if the txn is already associated with a CF alert, for the entity
--     2014/05/26    leushe              Added lookup of the result_type  by result_id 
--	   2016/02/03    leushe              Added default to local variable l_result_type. Defaults Result_type to 'UNKOWN'
--                                       Since an Alert can have a call result of null, we need to set a default for the type when the call result query returns 0 rows
--	   
------------------------------------------------------------------------
P1: BEGIN

    DECLARE l_rowcount INTEGER DEFAULT 0;
    DECLARE l_stmtTemplate varchar(4000);     
    DECLARE l_selectTemplate varchar(4000);     
    DECLARE l_tran_id BIGINT;
    DECLARE l_pos INTEGER;
    DECLARE l_length INTEGER;
    DECLARE l_result_type  varchar(10) DEFAULT 'UNKOWN';
    DECLARE v_sqlstate CHAR(5) DEFAULT '00000';
    DECLARE SQLSTATE CHAR(5) DEFAULT '00000';
    
    DECLARE l_stmt STATEMENT;
    DECLARE l_selectStmt STATEMENT;
    
    DECLARE c_stmt CURSOR for l_selectStmt;
    DECLARE CONTINUE HANDLER FOR SQLEXCEPTION, SQLWARNING, NOT FOUND
    	BEGIN
        set v_sqlstate = '99999';
      END;

    select result_type into l_result_type from fcm_call_result where result_id = i_result_id;
    
    SET l_selectTemplate='select cmx_tran_id from '|| i_tabname || ' where  ((cmx_cf_alert_version_'||i_alert_type||'_nbr =? and cmx_cf_alert_'||i_alert_type||'_id = ?) or cmx_cf_alert_'||i_alert_type||'_id is null)'
              ||' and cmx_tran_id in (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?, ?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?  ) ';
    SET l_stmtTemplate =
       ' UPDATE '|| i_tabname || ' SET cmx_user_fraud_'||i_alert_type||'_ind = (case when ( (cmx_cf_alert_'||i_alert_type||'_id = ? and cmx_cf_alert_version_'||i_alert_type||'_nbr = ?) or cmx_cf_alert_'||i_alert_type||'_id is null) ' 
      			||' then ? else cmx_user_fraud_'||i_alert_type||'_ind end) '
       			||',cmx_user_fraud_'||i_alert_type||'_timestamp = ( current timestamp - current timezone )'
       			||',cmx_lstupdt_user = ?,cmx_lstupdt_timestamp =  ( current timestamp - current timezone )'
       			--||',cmx_cf_alert_'||i_alert_type||'_id = (case when ? = ''0'' then null  when ( ? = 7 ) then ? else cmx_cf_alert_'||i_alert_type||'_id  END)'
       			||',cmx_cf_alert_'||i_alert_type||'_id = (case when ( (cmx_cf_alert_'||i_alert_type||'_id = ? and cmx_cf_alert_version_'||i_alert_type||'_nbr = ?) or cmx_cf_alert_'||i_alert_type||'_id is null) then ' 
        		||'      CASE when (? = ''0'') then null else case when ( ? = ''NEGATIVE'' ) then ? else cmx_cf_alert_'||i_alert_type||'_id  END END ELSE cmx_cf_alert_'||i_alert_type||'_id END)'
       			--||',cmx_cf_alert_version_'||i_alert_type||'_nbr = (case when ? = ''0'' then null  when ( ? = 7 ) then ? else cmx_cf_alert_version_'||i_alert_type||'_nbr  END) '
       			||',cmx_cf_alert_version_'||i_alert_type||'_nbr =	(case when ( (cmx_cf_alert_'||i_alert_type||'_id = ? and cmx_cf_alert_version_'||i_alert_type||'_nbr = ?) or cmx_cf_alert_'||i_alert_type||'_id is null) then ' 
          		||'       CASE when (? = ''0'') then null else  case when ( ? = ''NEGATIVE'' ) then ?  else cmx_cf_alert_version_'||i_alert_type||'_nbr  END END ELSE cmx_cf_alert_version_'||i_alert_type||'_nbr END) '        
       			--||' WHERE cmx_tran_id in (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?, ?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?  ) ' ;
       			||' WHERE cmx_tran_id = ? ' ;


    
          
          
        PREPARE l_selectStmt FROM l_selectTemplate;
      	OPEN c_stmt USING i_alert_Version_nbr,i_alert_id, i_transaction_id_1, i_transaction_id_2, i_transaction_id_3,
                i_transaction_id_4, i_transaction_id_5, i_transaction_id_6,
                i_transaction_id_7, i_transaction_id_8, i_transaction_id_9,
                i_transaction_id_10, i_transaction_id_11, i_transaction_id_12,
                i_transaction_id_13, i_transaction_id_14, i_transaction_id_15,
                i_transaction_id_16, i_transaction_id_17, i_transaction_id_18,
                i_transaction_id_19, i_transaction_id_20, i_transaction_id_21,
                i_transaction_id_22, i_transaction_id_23, i_transaction_id_24,
                i_transaction_id_25, 
                i_transaction_id_26, i_transaction_id_27, 
                i_transaction_id_28, i_transaction_id_29, 
                i_transaction_id_30, i_transaction_id_31, i_transaction_id_32,
                i_transaction_id_33, i_transaction_id_34, i_transaction_id_35,
                i_transaction_id_36, i_transaction_id_37, i_transaction_id_38,
                i_transaction_id_39, 
                i_transaction_id_40, i_transaction_id_41, i_transaction_id_42,
                i_transaction_id_43, i_transaction_id_44, i_transaction_id_45,
                i_transaction_id_46, i_transaction_id_47, i_transaction_id_48,
                i_transaction_id_49, i_transaction_id_50 ;
    		fetch from c_stmt into l_tran_id;
		    	SET v_sqlstate = SQLSTATE;
          
        while(v_sqlstate = '00000') do
		     
        
          INSERT into FMX_FRAUD_UPDT (CMX_TRAN_ID,TABLE_NAME, ALERT_ID,ALERT_VERSION_NBR,ALERT_TYPE, USER_FRAUD_IND,USER_FRAUD_TIMESTAMP, cmx_LSTUPDT_USER, cmx_LSTUPDT_TIMESTAMP) 
              values (l_tran_id,i_tabname,
              case when (i_fraud_ind='1' and l_result_type='NEGATIVE') then i_alert_id else null end,
              case when (i_fraud_ind='1' and l_result_type='NEGATIVE') then i_alert_version_nbr else null end,
              i_alert_Type,i_fraud_ind,current timestamp - current timezone ,i_user_name,current timestamp - current timezone );
       --       commit;
              
          PREPARE l_stmt FROM l_stmtTemplate;
	               
       		EXECUTE l_stmt USING
                i_alert_id,i_alert_Version_nbr,i_fraud_ind, i_user_name, 
                i_alert_id,i_alert_Version_nbr,i_fraud_ind,l_result_type,i_alert_id,
                i_alert_id,i_alert_Version_nbr,i_fraud_ind,l_result_type,i_alert_Version_nbr,l_tran_id;
                
          fetch from c_stmt into l_tran_id;
         
         
    END WHILE;

CLOSE c_stmt;
				



    --
    -- The commit/rollback decision has to be handled by the caller.
    --

    IF(i_need_to_commit = 'Y') THEN
      COMMIT;
    END IF;

  END P1@

--grant execute on specific procedure UPD_XACT_FRAUD_FL2 to role approle_d6@
